unit Unit1;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.Grids, Vcl.StdCtrls, Vcl.ExtCtrls,
  VclTee.TeeGDIPlus, VCLTee.TeEngine, VCLTee.TeeProcs, VCLTee.Chart;

type
  TCurrArray = array of currency;
  TActData = record
    ActName: string;
    Values: TCurrArray;
  end;

  PIncomeData = ^TIncomeData;

  TIncomeData = array of TActData;

  TForm1 = class(TForm)
    sgdData: TStringGrid;
    rbtIll1: TRadioButton;
    rbtIll2: TRadioButton;
    rbtIll3: TRadioButton;
    rbtIll4: TRadioButton;
    pnlHeader: TPanel;
    Chart1: TChart;
    cbxChartMethod: TComboBox;
    Label1: TLabel;
    procedure rbtIll1Click(Sender: TObject);
    procedure cbxChartMethodChange(Sender: TObject);
  private
    FChartData: array of TIncomeData;
    procedure UpdateGridData;
    function GetIncomeData: PIncomeData;
    procedure UpdateChart1;
    procedure UpdateChart2;
    procedure UpdateChart;
  public
    { Public declarations }
    constructor Create(aOwner: TComponent); override;
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

uses Math, VCLTee.Series;

{ TForm1 }

procedure TForm1.cbxChartMethodChange(Sender: TObject);
begin
 UpdateChart;
end;

constructor TForm1.Create(aOwner: TComponent);
var
  lIncomes: ^TIncomeData;
  lAct: ^TActData;
  lValues: array of currency;
  I: Integer;
  lCount: Integer;
  J: Integer;
begin
  inherited;

  SetLength(FChartData, 4);
  //
  // Illustration #1
  //
  lIncomes := @FChartData[0];
  SetLength(lIncomes^, 4); // 4 accounts

  lAct := @lIncomes^[0];
  lAct.ActName := 'Social Security';
  lAct.Values := TCurrArray.Create(0,0,5073.88,5226.1,5382.88,5544.37,5710.7,5882.02,6058.48,6240.23,6427.44,6620.26,6818.87,7023.43,7234.14,7451.16,7674.69,7904.93,8142.08,8386.34,8637.92,8897.07,9163.97,9438.9);

  lAct := @lIncomes^[1];
  lAct.ActName := 'Pre-Tax';
  lAct.Values := TCurrArray.Create(8906.34,8906.33,8906.33,8906.34,8906.33,8906.34,8906.34,8906.33,8906.33,8906.34,8906.34,8906.33,8906.34,8906.34,8906.34,8906.34,8906.34,8906.34,8906.34,8906.34,8906.34,8906.34,8906.34,8906.34);

  lAct := @lIncomes^[2];
  lAct.ActName := 'Roth';
  lAct.Values := TCurrArray.Create(0,0,0,0,0,0,0,0,0,0,901.08,897.28,889.45,885.4,881.21,876.84,867.8,863.11,853.36,848.28,837.68,826.66,815.17,0);

  lAct := @lIncomes^[3];
  lAct.ActName := 'Pre-Tax';
  lAct.Values := TCurrArray.Create(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0);

  //
  // Illustration #2
  //
  lIncomes := @FChartData[1];
  SetLength(lIncomes^, 4); // 4 accounts

  lAct := @lIncomes^[0];
  lAct.ActName := 'Social Security';
  lAct.Values := TCurrArray.Create(4771,4915,5062,5214,5370,5531,5697,5868,6044,6226,6412,6605,6803,7007,7217,7434,7657,7886,8123);

  lAct := @lIncomes^[1];
  lAct.ActName := 'Pre-Tax';
  lAct.Values := TCurrArray.Create(5389,5480,5644,5814,5988,6167,6353,6543,6739,6941,7150,7364,7585,7812,8046,8288,8536,4755,0);

  lAct := @lIncomes^[2];
  lAct.ActName := 'Roth';
  lAct.Values := TCurrArray.Create(955,971,1000,1030,1061,1093,1126,1160,1195,1231,1268,1306,1345,1386,1427,1470,1515,844,0);

  lAct := @lIncomes^[3];
  lAct.ActName := 'Shortfall';
  lAct.Values := TCurrArray.Create(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4753,10564);


  //
  // Illustration #3
  //
  lIncomes := @FChartData[2];
  SetLength(lIncomes^, 2); // 2 accounts

  lAct := @lIncomes^[0];
  lAct.ActName := 'Pre-Tax';
  lAct.Values := TCurrArray.Create(8906.34,8906.33,8906.33,8906.34,8906.33,8906.34,8906.34,8906.33,8906.33,8906.34,8906.34,8906.33,8906.34,8906.34,8906.34,8906.34,8906.34,8906.34,8906.34,8906.34,8906.34,8906.34,8906.34,8906.34);

  lAct := @lIncomes^[1];
  lAct.ActName := 'Shortfall';
  lAct.Values := TCurrArray.Create(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0);

  //
  // Illustration #4
  //
  lIncomes := @FChartData[3];
  SetLength(lIncomes^, 4); // 4 accounts

  lAct := @lIncomes^[0];
  lAct.ActName := 'Alabama TRS';
  lAct.Values := TCurrArray.Create(8906.34,8906.34,8906.34,8906.34,8906.34,8906.34,8906.34,8906.34,8906.34,8906.34,8906.34,8906.34,8906.34,8906.34,8906.34,8906.34,8906.34,8906.34,8906.34,8906.34,8906.34,8906.34,8906.34,8906.34);

  lAct := @lIncomes^[1];
  lAct.ActName := 'PLOP';
  lAct.Values := TCurrArray.Create(0,0,0,0,0,0,439.48,1089.95,1389.84,1698.72,2016.87,2344.57,2682.1,3029.76,3387.83,3756.66,330.88,0,0,0,0,0,0,0);

  lAct := @lIncomes^[2];
  lAct.ActName := 'Side Fund';
  lAct.Values := TCurrArray.Create(0,0,0,53.25,241.68,516.12,359.31,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0);

  lAct := @lIncomes^[3];
  lAct.ActName := 'Shortfall';
  lAct.Values := TCurrArray.Create(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3805.673333,4527.835,4930.86,5345.975,5773.545,6213.94,6667.545,6897.7);

  for I := 0 to High(FChartData) do begin
    lIncomes := @FChartData[I];
    if (High(lIncomes^) > 0) then begin
      lCount := Length(lIncomes^[0].Values);
      for J := 1 to High(lIncomes^) do
        Assert(lCount = Length(lIncomes^[J].Values), Format('for index %d, values should equal %d but equal %d', [I, lCount, Length(lIncomes^[I].Values)]));
    end;
  end;
end;

function TForm1.GetIncomeData: PIncomeData;
begin
  if rbtIll2.Checked then
   result := @FChartData[1]
  else if rbtIll3.Checked then
    result := @FChartData[2]
  else if rbtIll4.Checked then
    result := @FChartData[3]
  else
    result := @FChartData[0]
end;

procedure TForm1.rbtIll1Click(Sender: TObject);
begin
  UpdateGridData;
end;

procedure TForm1.UpdateChart2;

var
  lIncomes: PIncomeData;
  lLastValueIdx: integer;
  lValues: TCurrArray;

  function CreateChartSeries(aTitle: string): TAreaSeries;
  begin
    result := TAreaSeries.Create(self);
    result.ParentChart := Chart1;
    result.AreaLinesPen.Visible := false;
    result.Pen.Visible := false;
    result.Title := aTitle;
    result.MultiArea := maStacked;
  end;

  function GetHasStep(aIdx: integer): boolean;
  var
    I: integer;
    lAct: TActData;
  begin
    for I := 0 to high(lIncomes^) do begin
      lAct := lIncomes^[I];
      if (aIdx > 0) and (lAct.Values[aIdx-1] = 0) and (lAct.Values[aIdx] > 0) then
        exit(True)
      else if (aIdx < lLastValueIdx) and (lAct.Values[aIdx] > 0) and (lAct.Values[aIdx+1] = 0) then
        exit(True);
    end;
    result := false;
  end;

  function GetIsLastActWithIncome(aIdx: integer): boolean;
  var
    I: Integer;
  begin
    for I := high(lIncomes^) downto aIdx+1 do
      if lIncomes^[I].Values[aIdx] > 0 then
        exit(False);
    result := True;
  end;

var
  lHasStep: boolean;
  lLastActIdx: integer;
  lStepUpValue: currency;
  lStepDnValue: currency;
  lUsedUpValue: currency;
  lUsedDnValue: currency;
  I, J: Integer;
  lsrs: array of TAreaSeries;
begin
  Chart1.FreeAllSeries;
  lIncomes := GetIncomeData;


  lLastValueIdx := high(lIncomes^[0].Values);
  lLastActIdx := high(lIncomes^);

  //
  // preprere data with steps
  //

  SetLength(lsrs, Length(lIncomes^));
  for I := 0 to high(lIncomes^) do
    lsrs[I] := CreateChartSeries(lIncomes^[I].ActName);

  for I := 0 to lLastValueIdx do begin
    lHasStep := GetHasStep(I);
    lStepUpValue := 0;
    lStepDnValue := 0;

    for J := 0 to high(lIncomes^) do begin
      lValues := lIncomes^[J].Values;

      if lHasStep then begin
        if ((J = lLastActIdx) or GetIsLastActWithIncome(J)) then begin
          lUsedUpValue := lStepUpValue;
          lUsedDnValue := lStepDnValue;
          lStepUpValue := 0;
          lStepDnValue := 0;
        end else begin
          lUsedUpValue := 0;
          lUsedDnValue := 0;
        end;

        if (I > 0) and (lValues[I] > 0) and (lValues[I-1] = 0) then begin
          // step up
          lsrs[J].AddXY(I, 0 + lUsedUpValue);
          lsrs[J].AddXY(I, lValues[I] + lUsedDnValue);
          lStepUpValue := lStepUpValue + lValues[I];
        end else if (I < lLastValueIdx) and (lValues[I] > 0) and (lValues[I+1] = 0) then begin
          // step down
          lsrs[J].AddXY(I, lValues[I] + lUsedDnValue);
          lsrs[J].AddXY(I, 0 );
          lStepDnValue := lStepDnValue + lValues[I];
        end else begin
          lsrs[J].AddXY(I, lValues[I] );
          lsrs[J].AddXY(I, lValues[I] );
        end;
      end else begin
        if (lValues[I] > 0) then
          lsrs[J].AddXY(I, lValues[I])
        else
          lsrs[J].AddNullXY(I, 0);
      end;
    end;
  end;

end;

procedure TForm1.UpdateChart1;

  function CreateChartSeries(aTitle: string): TAreaSeries;
  begin
    result := TAreaSeries.Create(self);
    result.ParentChart := Chart1;
    result.AreaLinesPen.Visible := false;
    result.Pen.Visible := false;
    result.Title := aTitle;
    result.MultiArea := maStacked;
  end;

var
  lIncomes: PIncomeData;
  I, J: Integer;
  lAct: TActData;
  lsrs: TAreaSeries;
begin
  Chart1.FreeAllSeries;
  lIncomes := GetIncomeData;

  for I := 0 to High(lIncomes^) do begin
    lAct := lIncomes^[I];

    lsrs := CreateChartSeries(lAct.ActName);
    for J := 0 to High(lAct.Values) do
      lsrs.Add(lAct.Values[J]);
  end;
end;

procedure TForm1.UpdateChart;
begin
  if cbxChartMethod.ItemIndex = 0 then
    UpdateChart1
  else
    UpdateChart2;
end;

procedure TForm1.UpdateGridData;
var
  lIncomes: PIncomeData;
  I, J: Integer;
  lAct: TActData;
  lWidth: Integer;
begin
  lIncomes := GetIncomeData;

  sgdData.RowCount := Length(lIncomes^) + 1;

  if Length(lIncomes^) > 0 then begin
    sgdData.ColCount := Length(lIncomes^[0].Values) + 2;

    sgdData.Cells[0, 0] := 'Account';

    lWidth := 0;

    for I := 0 to High(lIncomes^) do begin
      lAct := lIncomes^[I];
      sgdData.Cells[0, I + 1] := lAct.ActName;
      lWidth := Max(lWidth, Canvas.TextWidth(lAct.ActName));

      for J := 0 to High(lAct.Values) do
        sgdData.Cells[J + 1, I + 1] := CurrToStr(lAct.Values[J]);
    end;

    sgdData.ColWidths[0] := lWidth + 5;
  end;

  UpdateChart;
end;

end.
